#!/usr/bin/env python

import sys
import os
import re

regexToSearch = [
 [r"exec" , re.IGNORECASE ] ,
 [r"system" , re.IGNORECASE ] ,
 [r"passthru" , re.IGNORECASE ] ,
 [r"system" , re.IGNORECASE ] ,
 [r"pcntl_exec" , re.IGNORECASE ] ,
 [r"eval" , re.IGNORECASE ] ,
 [r"popen" , re.IGNORECASE ]
]
compiledRegex = []

def isFolder( szPath ) :
	return os.path.isdir( szPath )

def isFile( szPath ) :
	return os.path.isfile( szPath )

def logInformation( lineNumber , lineText , szPath ) :
	
	print "In %s at line %d found" % ( szPath , lineNumber )
	print lineText.rstrip() + '\n'


def checkLine( textToSearch ) :

	for regexPattern in compiledRegex :
		matchedObject = regexPattern.search( textToSearch )

		if matchedObject :
			return True

	return False

def readFolder( szPath ) :

	for dirPath, dirNames, listFileNames in os.walk( szPath ) :

		for fileName in listFileNames :
			processFile( os.path.join( dirPath, fileName ) );


def processFile( szPath ) :

	try :
		with open( szPath , "rt" ) as filePointer :	
			
			currentLine = 0

			for lineText in filePointer :
				
				currentLine += 1

				if not checkLine( lineText ) :
					continue

				logInformation( currentLine , lineText , szPath )

	except IOError:
		return


if __name__ == "__main__" :

	sys.argv = sys.argv[ 1: ]

	if len( sys.argv ) <= 0 :
		print "At least 1 argument to file or folder"
		print "check_IsBackDoor.py <agument file path , file name >"
		
		sys.exit( 0 )

	for regexPattern,regexFlags in regexToSearch :
		compiledRegex.append( re.compile( regexPattern , regexFlags ) )


	for argvOption in sys.argv :

		if isFolder( argvOption ) :
			readFolder( argvOption )
		
		elif isFile( argvOption ) :
			processFile( argvOption );
